Loading...
Searching...
No Matches
BALL::PoseClustering Class Reference

Computation of clusters of docking poses. More...

`#include <BALL/DOCKING/COMMON/poseClustering.h>`

## Classes

struct | Option
| Option names. More...
struct | Default
| Default values for options. More...
class | RigidTransformation
class | PosePointer
class | ClusterProperties
class | ClusterTreeWriter_
class | ClusterTreeNodeComparator

## Public Member Functions

operation methods
bool | compute ()
Access methods
void | setConformationSet (ConformationSet *new_set, bool precompute_atombijection=false)
| sets the poses to be clustered, the conformation set's reference system will the base system
void | setBaseSystemAndPoses (System const &base_system, std::vector< PosePointer > const &poses)
void | setBaseSystemAndTransformations (System const &base_system, String transformation_file_name)
const ConformationSet * | getConformationSet () const
| returns the poses to be clustered as ConformationSet
ConformationSet * | getConformationSet ()
| returns the poses to be clustered as ConformationSet
const std::vector< RigidTransformation > & | getRigidTransformations () const
| returns the poses as rigid transformations
std::vector< Vector3 > & | getCentersOfMass ()
| returns the centers of mass-vector (non-empty only for CENTER_OF_MASS_DISTANCE)
std::vector< Vector3 > const & | getCentersOfMass () const
| returns the centers of mass-vector, const version (non-empty only for CENTER_OF_MASS_DISTANCE)
const System & | getSystem () const
| returns the reference pose
System & | getSystem ()
| returns the reference pose
Size | getNumberOfPoses () const
| returns the number of poses
Size | getNumberOfClusters () const
| returns the number of clusters found
const std::set< Index > & | getCluster (Index i) const
std::set< Index > & | getCluster (Index i)
Size | getClusterSize (Index i) const
| returns the size of cluster i
float | getClusterScore (Index i) const
| returns the score of cluster i
float | getScore (const System sys_a, const System sys_b, Options options) const
| returns the score between two poses given as systems
AtomBijection & | getAtomBijection ()
| returns a reference to the cached AtomBijection
AtomBijection const & | getAtomBijection () const
| returns a const reference to the cached AtomBijection
void | applyTransformation2System (Index i, System &target_system)
| apply a transformation to a given system
void | convertTransformations2Snaphots ()
| convert the poses to SnapShots
void | convertSnaphots2Transformations ()
| convert the poses to rigid transformations
float | computeCompleteLinkageRMSD (Index i, Options options, bool initialize=true)
| returns the complete linkage RMSD of cluster i
boost::shared_ptr< System > | getPose (Index i) const
| returns the complete linkage RMSD of a pose set
std::vector< PosePointer > const & | getPoses () const
| returns poses as PosePointer
boost::shared_ptr< System > | getClusterRepresentative (Index i)
| returns the "central cluster" conformation of cluster i as system
Index | findClusterRepresentative (Index i)
| returns the index of the cluster representative
boost::shared_ptr< ConformationSet > | getClusterConformationSet (Index i)
| returns cluster i as ConformationSet
boost::shared_ptr< ConformationSet > | getReducedConformationSet ()
| returns a ConformationSet containing one structure per cluster
bool | refineClustering (Options const &refined_options)

## Static Public Member Functions

rigid transformation methods
static float | getRigidRMSD (Eigen::Vector3f const &t_ab, Eigen::Matrix3f const &M_ab, Eigen::Matrix3f const &covariance_matrix)
static float | getSquaredRigidRMSD (Eigen::Vector3f const &t_ab, Eigen::Matrix3f const &M_ab, Eigen::Matrix3f const &covariance_matrix)
static Eigen::Matrix3f | computeCovarianceMatrix (System const &system, Index rmsd_level_of_detail=C_ALPHA)

## Constant Definitions

typedef boost::adjacency_list< boost::vecS, boost::vecS, boost::directedS, ClusterProperties, boost::no_property, unsigned int > | ClusterTree
typedef ClusterTree::vertex_descriptor | ClusterTreeNode
| BALL_CREATE (PoseClustering)
| PoseClustering ()
| Default constructor.
| PoseClustering (ConformationSet *poses, float rmsd)
| PoseClustering (System const &base_system, String transformation_file_name)
| PoseClustering for a given set of rigid transformations of a base structure.
virtual | ~PoseClustering ()

## Public Attributes

Options | options
| options
void | setDefaultOptions ()

## methods given a full clustering

Eigen::MatrixXd | pairwise_scores_
ConformationSet * | current_set_
| the ConformationSet we wish to cluster
std::vector< std::set< Index > > | clusters_
| the clusters: sets of pose indices
std::vector< Index > | cluster_representatives_
std::vector< float > | cluster_scores_
| the scores of the clusters
Index | rmsd_level_of_detail_
| the RMSD definition used for clustering
std::vector< PosePointer > | poses_
std::vector< RigidTransformation > | transformations_
Eigen::Matrix3f | covariance_matrix_
System | base_system_
SnapShot | base_conformation_
bool | has_rigid_transformations_
bool | delete_conformation_set_
std::vector< double > | lambda_
std::vector< int > | pi_
std::vector< double > | mu_
Size | number_of_selected_atoms_
std::vector< Vector3 > | com_
AtomBijection | atom_bijection_
System | system_i_
System | system_j_
ClusterTree | cluster_tree_
| The tree built during hierarchical clustering.
std::vector< std::set< Index > > | extractClustersForThreshold (float threshold, Size min_size=0)
std::vector< std::set< Index > > | extractNBestClusters (Size n)
std::vector< std::set< Index > > | filterClusters (Size min_size=1)
void | serializeWardClusterTree (std::ostream &out, bool binary=false)
void | deserializeWardClusterTree (std::istream &in, bool binary=false)
void | exportWardClusterTreeToGraphViz (std::ostream &out)
void | exportClusterTreeToJSON (std::ostream &out)
void | printClusters (std::ostream &out=std::cout) const
void | printClusterScores (std::ostream &out=std::cout)
bool | trivialCompute_ ()
bool | linearSpaceCompute_ ()
bool | althausCompute_ ()
void | slinkInner_ (int current_level)
void | clinkInner_ (int current_level)
bool | nearestNeighborChainCompute_ ()
void | initWardDistance_ (Index rmsd_type)
void | updateWardDistance_ (ClusterTreeNode parent, ClusterTreeNode i, ClusterTreeNode j, Index rmsd_type)
float | computeWardDistance_ (ClusterTreeNode i, ClusterTreeNode j, Index rmsd_type)
std::set< Index > | collectClusterBelow_ (ClusterTreeNode const &v)
void | computeCenterOfMasses_ ()
void | precomputeAtomBijection_ ()
float | getClusterRMSD_ (Index i, Index j, Index rmsd_type)
bool | readTransformationsFromFile_ (String filename)
float | getRMSD_ (Index i, Index j, Index rmsd_type)
void | storeSnapShotReferences_ ()
void | printCluster_ (Size i, std::ostream &out=std::cout) const
void | printVariables_ (int a, int b, double c, int d, double e, int current_level)
void | clear_ ()
void | exportToJSONDFS_ (ClusterTreeNode const &current, String &result)
static bool | isExcludedByLevelOfDetail_ (Atom const *atom, Index rmsd_level_of_detail)

## Detailed Description

Computation of clusters of docking poses.

Pose Clustering

This class computes clusters of docking poses given as a conformation set using a complete linkage algorithm.

The class assumes the following setup

- a pairwise rigid protein-protein docking
- all receptor-ligand poses have already been mapped onto each other such that the "receptors" are kept fixed
- the given pose set only contains the "ligands"

We offer several algorithms via the option CLUSTER_METHOD:

- TRIVIAL_COMPLETE_LINKAGE: a naive implementation, that guarantees an optimal final partition.
- CLINK_DEFAYS as described in D. Defays: An efficient algorithm for a complete link method. The Computer Journal. 20, 4, British Computer Society, 1977, p. 364-366. Please note that this implementation does not guarantee to find the best final clustering!
- NEAREST_NEIGHBOR_CHAIN_WARD as described in Murtagh, Fionn (1983): "A survey of recent advances in hierarchical clustering algorithms", The Computer Journal 26 (4): 354–359
  Note that this algorithm computes a full clustering.
- SLINK_SIBSON as described in R. Sibson: SLINK: an optimally efficient algorithm for the single-link cluster method. The Computer Journal. 16, 1, British Computer Society, 1973, p. 30-34

The scope of the scoring (the atoms to be considered) can be defined via the option RMSD_LEVEL_OF_DETAIL. If the option is set to PROPERTY_BASED_ATOM_BIJECTION, arbitrary sets of atoms, e.g. binding pockets, can be used by assigning property named "ATOMBIJECTION_RMSD_SELECTION" to the respective atoms in the reference system. See also BALL::Expression.

The minimal rmsd or ward distance between the final clusters can be defined via option DISTANCE_THRESHOLD. In order to relate RMSD and ward distance, we use sqrt(ward_dist / number_of_selected_atoms) for threshold extraction.

The nearest neighbor chain ward clustering in principle computes a full clustering. Option DISTANCE_THRESHOLD gives a ward distance that is automatically used to extract clusters. Further extractions with different thresholds are possible.

The complete linkage algorithms guarantee a minimal cluster distance (max RMSD between all pairs of two clusters), specified with option DISTANCE_THRESHOLD.

The initial poses can be given as ConformationSet or as transformation file, i.e. translation and rotation of each pose. Depending on this choice, the option RMSD_TYPE has to be set to SNAPSHOT_RMSD or RIGID_RMSD. If RMSD_TYPE is set to CENTER_OF_MASS_DISTANCE, the option RMSD_LEVEL_OF_DETAIL will be ignored.

By setting the option RUN_PARALLEL to true, the user can request parallel execution. This will be performed if the execution environment is enabled (BALL_HAS_TBB), and if the algorithm supports it.

Definition at line 126 of file poseClustering.h.

## Member Typedef Documentation

## ClusterTree

typedef boost::adjacency_list<boost::vecS, boost::vecS, boost::directedS, ClusterProperties, boost::no_property, unsigned int> BALL::PoseClustering::ClusterTree

Definition at line 277 of file poseClustering.h.

## ClusterTreeNode

typedef ClusterTree::vertex_descriptor BALL::PoseClustering::ClusterTreeNode

Definition at line 279 of file poseClustering.h.

## Constructor & Destructor Documentation

## PoseClustering() [1/3]

BALL::PoseClustering::PoseClustering | ( |  | ) |

Default constructor.

Constructors and Destructor

## PoseClustering() [2/3]

BALL::PoseClustering::PoseClustering | ( | ConformationSet * | poses,
|  | float | rmsd )

Detailed constructor. (TODO: really pass a pointer here?)

## PoseClustering() [3/3]

BALL::PoseClustering::PoseClustering | ( | System const & | base_system,
|  | String | transformation_file_name )

PoseClustering for a given set of rigid transformations of a base structure.

## ~PoseClustering()

virtual BALL::PoseClustering::~PoseClustering | ( |  | ) |

virtual

## Member Function Documentation

## althausCompute_()

bool BALL::PoseClustering::althausCompute_ | ( |  | ) |

protected

## applyTransformation2System()

void BALL::PoseClustering::applyTransformation2System | ( | Index | i,
|  | System & | target_system )

apply a transformation to a given system

## BALL_CREATE()

BALL::PoseClustering::BALL_CREATE | ( | PoseClustering |  | ) |

## clear_()

void BALL::PoseClustering::clear_ | ( |  | ) |

protected

## clinkInner_()

void BALL::PoseClustering::clinkInner_ | ( | int | current_level | ) |

protected

## collectClusterBelow_()

std::set< Index > BALL::PoseClustering::collectClusterBelow_ | ( | ClusterTreeNode const & | v | ) |

protected

## compute()

bool BALL::PoseClustering::compute | ( |  | ) |

start method.

## computeCenterOfMasses_()

void BALL::PoseClustering::computeCenterOfMasses_ | ( |  | ) |

protected

## computeCompleteLinkageRMSD()

float BALL::PoseClustering::computeCompleteLinkageRMSD | ( | Index | i,
|  | Options | options,
|  | bool | initialize = true )

returns the complete linkage RMSD of cluster i

## computeCovarianceMatrix()

Eigen::Matrix3f BALL::PoseClustering::computeCovarianceMatrix | ( | System const & | system,
|  | Index | rmsd_level_of_detail = C_ALPHA )

static

Compute the covariance matrix for the given system

## computeWardDistance_()

float BALL::PoseClustering::computeWardDistance_ | ( | ClusterTreeNode | i,
|  | ClusterTreeNode | j,
|  | Index | rmsd_type )

protected

## convertSnaphots2Transformations()

void BALL::PoseClustering::convertSnaphots2Transformations | ( |  | ) |

convert the poses to rigid transformations

## convertTransformations2Snaphots()

void BALL::PoseClustering::convertTransformations2Snaphots | ( |  | ) |

convert the poses to SnapShots

## deserializeWardClusterTree()

void BALL::PoseClustering::deserializeWardClusterTree | ( | std::istream & | in,
|  | bool | binary = false )

Import the cluster tree from boost::serialize format.

## exportClusterTreeToJSON()

void BALL::PoseClustering::exportClusterTreeToJSON | ( | std::ostream & | out | ) |

Export the cluster tree in JSON format.

## exportToJSONDFS_()

void BALL::PoseClustering::exportToJSONDFS_ | ( | ClusterTreeNode const & | current,
|  | String & | result )

protected

## exportWardClusterTreeToGraphViz()

void BALL::PoseClustering::exportWardClusterTreeToGraphViz | ( | std::ostream & | out | ) |

Export the cluster tree in graphviz format.

## extractClustersForThreshold()

std::vector< std::set< Index > > BALL::PoseClustering::extractClustersForThreshold | ( | float | threshold,
|  | Size | min_size = 0 )

Extract clusters wrt a threshold if a complete clustering was performed Note: the Ward distance does not equal the rmsd. We use threshold = sqrt(ward_dist / number_of_selected_atoms). see NEAREST_NEIGHBOR_CHAIN_WARD

## extractNBestClusters()

std::vector< std::set< Index > > BALL::PoseClustering::extractNBestClusters | ( | Size | n | ) |

returns the first up to n clusters if previously a complete clustering was performed see NEAREST_NEIGHBOR_CHAIN_WARD

## filterClusters()

std::vector< std::set< Index > > BALL::PoseClustering::filterClusters | ( | Size | min_size = 1 | ) |

filters the current cluster set wrt to a minimal cluster size see NEAREST_NEIGHBOR_CHAIN_WARD

## findClusterRepresentative()

Index BALL::PoseClustering::findClusterRepresentative | ( | Index | i | ) |

returns the index of the cluster representative

## getAtomBijection() [1/2]

AtomBijection & BALL::PoseClustering::getAtomBijection | ( |  | ) |

inline

returns a reference to the cached AtomBijection

Definition at line 373 of file poseClustering.h.

## getAtomBijection() [2/2]

AtomBijection const & BALL::PoseClustering::getAtomBijection | ( |  | ) | const

inline

returns a const reference to the cached AtomBijection

Definition at line 376 of file poseClustering.h.

## getCentersOfMass() [1/2]

std::vector< Vector3 > & BALL::PoseClustering::getCentersOfMass | ( |  | ) |

inline

returns the centers of mass-vector (non-empty only for CENTER_OF_MASS_DISTANCE)

Definition at line 338 of file poseClustering.h.

## getCentersOfMass() [2/2]

std::vector< Vector3 > const & BALL::PoseClustering::getCentersOfMass | ( |  | ) | const

inline

returns the centers of mass-vector, const version (non-empty only for CENTER_OF_MASS_DISTANCE)

Definition at line 341 of file poseClustering.h.

## getCluster() [1/2]

std::set< Index > & BALL::PoseClustering::getCluster | ( | Index | i | ) |

returns indices of all poses assigned to cluster i Note: enumeration starts with 0

## getCluster() [2/2]

const std::set< Index > & BALL::PoseClustering::getCluster | ( | Index | i | ) | const

returns indices of all poses assigned to cluster i Note: enumeration starts with 0

## getClusterConformationSet()

boost::shared_ptr< ConformationSet > BALL::PoseClustering::getClusterConformationSet | ( | Index | i | ) |

returns cluster i as ConformationSet

## getClusterRepresentative()

boost::shared_ptr< System > BALL::PoseClustering::getClusterRepresentative | ( | Index | i | ) |

returns the "central cluster" conformation of cluster i as system

## getClusterRMSD_()

float BALL::PoseClustering::getClusterRMSD_ | ( | Index | i,
|  | Index | j,
|  | Index | rmsd_type )

protected

## getClusterScore()

float BALL::PoseClustering::getClusterScore | ( | Index | i | ) | const

returns the score of cluster i

## getClusterSize()

Size BALL::PoseClustering::getClusterSize | ( | Index | i | ) | const

returns the size of cluster i

## getConformationSet() [1/2]

ConformationSet * BALL::PoseClustering::getConformationSet | ( |  | ) |

inline

returns the poses to be clustered as ConformationSet

Definition at line 332 of file poseClustering.h.

## getConformationSet() [2/2]

const ConformationSet * BALL::PoseClustering::getConformationSet | ( |  | ) | const

inline

returns the poses to be clustered as ConformationSet

Definition at line 329 of file poseClustering.h.

## getNumberOfClusters()

Size BALL::PoseClustering::getNumberOfClusters | ( |  | ) | const

inline

returns the number of clusters found

Definition at line 353 of file poseClustering.h.

## getNumberOfPoses()

Size BALL::PoseClustering::getNumberOfPoses | ( |  | ) | const

inline

returns the number of poses

Definition at line 350 of file poseClustering.h.

## getPose()

boost::shared_ptr< System > BALL::PoseClustering::getPose | ( | Index | i | ) | const

returns the complete linkage RMSD of a pose set

returns the pose i as system

## getPoses()

std::vector< PosePointer > const & BALL::PoseClustering::getPoses | ( |  | ) | const

inline

returns poses as PosePointer

Definition at line 397 of file poseClustering.h.

## getReducedConformationSet()

boost::shared_ptr< ConformationSet > BALL::PoseClustering::getReducedConformationSet | ( |  | ) |

returns a ConformationSet containing one structure per cluster

## getRigidRMSD()

float BALL::PoseClustering::getRigidRMSD | ( | Eigen::Vector3f const & | t_ab,
|  | Eigen::Matrix3f const & | M_ab,
|  | Eigen::Matrix3f const & | covariance_matrix )

static

Compute the root mean square deviation due to a rigid transformation of a point cloud (here, atoms)

Parameters

  t_ab | difference vector between the transformations to be compared
  M_ab | difference of the rotation matrices between the transformations to be compared
  covariance_matrix | the covariance matrix of the atom positions

## getRigidTransformations()

const std::vector< RigidTransformation > & BALL::PoseClustering::getRigidTransformations | ( |  | ) | const

inline

returns the poses as rigid transformations

Definition at line 335 of file poseClustering.h.

## getRMSD_()

float BALL::PoseClustering::getRMSD_ | ( | Index | i,
|  | Index | j,
|  | Index | rmsd_type )

protected

## getScore()

float BALL::PoseClustering::getScore | ( | const System | sys_a,
|  | const System | sys_b,
|  | Options | options ) const

returns the score between two poses given as systems

## getSquaredRigidRMSD()

float BALL::PoseClustering::getSquaredRigidRMSD | ( | Eigen::Vector3f const & | t_ab,
|  | Eigen::Matrix3f const & | M_ab,
|  | Eigen::Matrix3f const & | covariance_matrix )

static

Compute the mean square deviation due to a rigid transformation of a point cloud (here, atoms)

Parameters

  t_ab | difference vector between the transformations to be compared
  M_ab | difference of the rotation matrices between the transformations to be compared
  covariance_matrix | the covariance matrix of the atom positions

## getSystem() [1/2]

System & BALL::PoseClustering::getSystem | ( |  | ) |

returns the reference pose

## getSystem() [2/2]

const System & BALL::PoseClustering::getSystem | ( |  | ) | const

returns the reference pose

## initWardDistance_()

void BALL::PoseClustering::initWardDistance_ | ( | Index | rmsd_type | ) |

protected

## isExcludedByLevelOfDetail_()

bool BALL::PoseClustering::isExcludedByLevelOfDetail_ | ( | Atom const * | atom,
|  | Index | rmsd_level_of_detail )

static protected

## linearSpaceCompute_()

bool BALL::PoseClustering::linearSpaceCompute_ | ( |  | ) |

protected

## nearestNeighborChainCompute_()

bool BALL::PoseClustering::nearestNeighborChainCompute_ | ( |  | ) |

protected

## precomputeAtomBijection_()

void BALL::PoseClustering::precomputeAtomBijection_ | ( |  | ) |

protected

## printCluster_()

void BALL::PoseClustering::printCluster_ | ( | Size | i,
|  | std::ostream & | out = std::cout ) const

protected

## printClusters()

void BALL::PoseClustering::printClusters | ( | std::ostream & | out = std::cout | ) | const

print the clusters as set of pose indices Note: start counting with 0

## printClusterScores()

void BALL::PoseClustering::printClusterScores | ( | std::ostream & | out = std::cout | ) |

print clusters of pose indices with RMSD between clusters Note: start counting with 0

## printVariables_()

void BALL::PoseClustering::printVariables_ | ( | int | a,
|  | int | b,
|  | double | c,
|  | int | d,
|  | double | e,
|  | int | current_level )

protected

## readTransformationsFromFile_()

bool BALL::PoseClustering::readTransformationsFromFile_ | ( | String | filename | ) |

protected

## refineClustering()

bool BALL::PoseClustering::refineClustering | ( | Options const & | refined_options | ) |

Refine a given clustering. This function can be used to refine a precomputed clustering further. An important use case would be to pre-cluster using an efficient rmsd implementation (e.g., center of mass or rigid rmsd), and then refine the resulting clusters with the general (i.e., snapshot based) rmsd.

NOTE: This function requires that clusters have already been computed. In the case of a full hierarchical clustering, extractClustersForThreshold or extractNBestClusters must have been called previously.

Parameters

  refined_options | The parameters for the refinment step.

## serializeWardClusterTree()

void BALL::PoseClustering::serializeWardClusterTree | ( | std::ostream & | out,
|  | bool | binary = false )

Export the cluster tree to boost::serialize format.

## setBaseSystemAndPoses()

void BALL::PoseClustering::setBaseSystemAndPoses | ( | System const & | base_system,
|  | std::vector< PosePointer > const & | poses )

Set a vector of PosePointers to be clustered Poses (RigidTransformations or SnapShots) can live outside of this class and will not be destroyed.

## setBaseSystemAndTransformations()

void BALL::PoseClustering::setBaseSystemAndTransformations | ( | System const & | base_system,
|  | String | transformation_file_name )

reads the poses given as transformations from a file and update the covariance matrix
Note: the given system will be taken as reference, e.g. all transformations

## setConformationSet()

void BALL::PoseClustering::setConformationSet | ( | ConformationSet * | new_set,
|  | bool | precompute_atombijection = false )

sets the poses to be clustered, the conformation set's reference system will the base system

## setDefaultOptions()

void BALL::PoseClustering::setDefaultOptions | ( |  | ) |

reset the options to default values

## slinkInner_()

void BALL::PoseClustering::slinkInner_ | ( | int | current_level | ) |

protected

## storeSnapShotReferences_()

void BALL::PoseClustering::storeSnapShotReferences_ | ( |  | ) |

protected

## trivialCompute_()

bool BALL::PoseClustering::trivialCompute_ | ( |  | ) |

protected

## updateWardDistance_()

void BALL::PoseClustering::updateWardDistance_ | ( | ClusterTreeNode | parent,
|  | ClusterTreeNode | i,
|  | ClusterTreeNode | j,
|  | Index | rmsd_type )

protected

## Member Data Documentation

## atom_bijection_

AtomBijection BALL::PoseClustering::atom_bijection_

protected

Definition at line 733 of file poseClustering.h.

## base_conformation_

SnapShot BALL::PoseClustering::base_conformation_

protected

Definition at line 698 of file poseClustering.h.

## base_system_

System BALL::PoseClustering::base_system_

protected

Definition at line 695 of file poseClustering.h.

## cluster_representatives_

std::vector< Index > BALL::PoseClustering::cluster_representatives_

protected

Definition at line 676 of file poseClustering.h.

## cluster_scores_

std::vector< float > BALL::PoseClustering::cluster_scores_

protected

the scores of the clusters

Definition at line 679 of file poseClustering.h.

## cluster_tree_

ClusterTree BALL::PoseClustering::cluster_tree_

protected

The tree built during hierarchical clustering.

Definition at line 740 of file poseClustering.h.

## clusters_

std::vector< std::set<Index> > BALL::PoseClustering::clusters_

protected

the clusters: sets of pose indices

Definition at line 674 of file poseClustering.h.

## com_

std::vector<Vector3> BALL::PoseClustering::com_

protected

Definition at line 726 of file poseClustering.h.

## covariance_matrix_

Eigen::Matrix3f BALL::PoseClustering::covariance_matrix_

protected

Definition at line 692 of file poseClustering.h.

## current_set_

ConformationSet* BALL::PoseClustering::current_set_

protected

the ConformationSet we wish to cluster

Definition at line 671 of file poseClustering.h.

## delete_conformation_set_

bool BALL::PoseClustering::delete_conformation_set_

protected

Definition at line 705 of file poseClustering.h.

## has_rigid_transformations_

bool BALL::PoseClustering::has_rigid_transformations_

protected

Definition at line 701 of file poseClustering.h.

## lambda_

std::vector<double> BALL::PoseClustering::lambda_

protected

Definition at line 711 of file poseClustering.h.

## mu_

std::vector<double> BALL::PoseClustering::mu_

protected

Definition at line 717 of file poseClustering.h.

## number_of_selected_atoms_

Size BALL::PoseClustering::number_of_selected_atoms_

protected

Definition at line 721 of file poseClustering.h.

## options

Options BALL::PoseClustering::options

options

Definition at line 432 of file poseClustering.h.

## pairwise_scores_

Eigen::MatrixXd BALL::PoseClustering::pairwise_scores_

protected

Definition at line 668 of file poseClustering.h.

## pi_

std::vector<int> BALL::PoseClustering::pi_

protected

Definition at line 715 of file poseClustering.h.

## poses_

std::vector<PosePointer> BALL::PoseClustering::poses_

protected

Definition at line 687 of file poseClustering.h.

## rmsd_level_of_detail_

Index BALL::PoseClustering::rmsd_level_of_detail_

protected

the RMSD definition used for clustering

Definition at line 682 of file poseClustering.h.

## system_i_

System BALL::PoseClustering::system_i_

protected

Definition at line 736 of file poseClustering.h.

## system_j_

System BALL::PoseClustering::system_j_

protected

Definition at line 737 of file poseClustering.h.

## transformations_

std::vector<RigidTransformation> BALL::PoseClustering::transformations_

protected

Definition at line 690 of file poseClustering.h.